<?php
/**
 * module_googlebuzz
 * @author Walter Cedric
 * @link http://www.waltercdric.com
 *
 * Based on:
 * 
 * Plugin Name: Google Buzz ER
 * Plugin URI: http://workshop.rs/2010/02/google-buzz-er-google-buzz-for-wordpress/
 * Description: Displaying posts from Google Buzz.
 * Version: 1.2
 * Author: Ivan Lazarevic
 * Author URI: http://www.workshop.rs
 *
 * Copyright 2010  Ivan Lazarevic  (email : devet.sest@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 **/

defined('_JEXEC') or die('Restricted access');

DEFINE('_GOOGLEBUZZ_API',"http://buzz.googleapis.com/feeds/");

new GoogleBuzz($params);

class GoogleBuzz
{
	var $params = null;

	function __construct($params)
	{
		$this->params = $params;
		$this->addCss();
		$this->getData();
	}

	function addCss(){
		$document =& JFactory::getDocument();
		$document->addStyleSheet('modules/mod_googlebuzz/css/googlebuzz.css');
	}

	function getData()
	{
		$user		=   $this->params->get('user');

		$xml = @simplexml_load_file(_GOOGLEBUZZ_API.$user."/public/posted");
		if(!$xml) {
			echo "Error loading Google Buzz with username ".$user;
			return false;
		}
		foreach($xml->entry as $data){
			if($data->content){
				$tmp['content'] 	= (string)$data->content;
				$tmp['name'] 		= $data->author->name;
				$tmp['uri'] 		= $data->author->uri;
				$tmp['updated']		= $data->updated;
				$tmp['href'] 		= $data->link['href'];
				$tmp['timestamp']	= strtotime($data->updated);
				$sts[] = $tmp;
			}
		}

		// sorting
		$tmp = $sts;
		foreach ($tmp as $key=>$row) {
			$text[$key] = $row['timestamp'];
		}
		array_multisort($text,SORT_DESC,$tmp);
		$sts = $tmp;

		$this->echoData($sts);
	}

	function echoData($data)
	{
		$count = $this->params->get('count');
		$out = "
		<div id='module'>
		<div id='googlebuzz_wrapper'>
			<div id='googlebuzz_title'>
				<a href='{$data[0]['uri']}'>{$data[0]['name']}</a>
			</div>";

		$i = 0;
		foreach($data as $k=>$v){
			$out .= "<br />
			<div class='googlebuzz_post'>
			{$v['content']}
				<span class='googlebuzz_time'>{$this->getTime(strtotime($v['updated']))}, </span>
				<span class='googlebuzz_comment'><a href='{$v['href']}'>comment</a></span>
			</div>";
			$i++;
			if($i == $count) {
				break;
			}
		}

		$out .= "
			<a href='http://www.google.com/buzz' id='googlebuzz_small'>&nbsp;</a>
		</div>
		</div>";

		print($out);
	}

	/**
	 * private
	 * @param $ts
	 * @return unknown_type
	 */
	function getTime($ts){
		$c = time() - $ts;
		$nd = date('g:i A M d\, Y',$ts);

		if ($c < 60)
		{
			return $c.' seconds ago';
		}
		elseif  ($c < 3600)
		{
			return (int)($c/60).' minutes ago';
		}
		elseif ($c < 3600*24) {
			return (int)($c/3600).' hours ago';
		}
		return $nd;
	}
}
?>